//用户自定义拓展，需要在fair_basic_config.json中注册
//会在基础js加载之后加载
let fairSPCallBack = {};
let fairSPCallBackId = 0;
let _fairSPCommonFunc = function (resp, methodName) {
   let respMap = {};
   respMap = mapOrSetToObject(resp);
   let id = 'FairSP$' + (++fairSPCallBackId);
   let requestParameter = {};
   requestParameter['className'] = "FairSP#"+methodName;
   fairSPCallBack[id] = respMap['callback'];
   respMap['callId'] = id;
   requestParameter['funcName'] = 'invokePlugin';
   requestParameter['pageName'] = respMap['pageName'];
   requestParameter['args'] = respMap;
   let map = JSON.stringify(requestParameter);
   invokeFlutterCommonChannel(map, (resultStr) => {
       let responseMap = JSON.parse(resultStr);
       let data = responseMap['data']
       let id = responseMap['callId']
       if (callBack[id] === null) {
           return;
       }

       let callback = fairSPCallBack[id];
       if (callback != null) {
           callback(data);
       }
   })
};

let FairSP = function () {
    return {
        getObject: function (resp) {
            _fairSPCommonFunc(resp, 'getObject');
        },
        putObject: function (resp) {
            _fairSPCommonFunc(resp, 'putObject');
        },
        getBool: function (resp) {
            _fairSPCommonFunc(resp, 'getBool');
        },
        putBool: function (resp) {
            _fairSPCommonFunc(resp, 'putBool');
        },
        getInt: function (resp) {
            _fairSPCommonFunc(resp, 'getInt');
        },
        putInt: function (resp) {
            _fairSPCommonFunc(resp, 'putInt');
        },
        getDouble: function (resp) {
            _fairSPCommonFunc(resp, 'getDouble');
        },
        putDouble: function (resp) {
            _fairSPCommonFunc(resp, 'putDouble');
        },
        getString: function (resp) {
            _fairSPCommonFunc(resp, 'getString');
        },
        putString: function (resp) {
            _fairSPCommonFunc(resp, 'putString');
        },
        getStringList: function (resp) {
            _fairSPCommonFunc(resp, 'getStringList');
        },
        putStringList: function (resp) {
            _fairSPCommonFunc(resp, 'putStringList');
        },
        getDynamic: function (resp) {
            _fairSPCommonFunc(resp, 'getDynamic');
        }
    }
}

